var __jtolog = '';
function jot(x) { __jtolog += x + "\n"; }

__alert = alert;
alert = function(etc) { __alert(etc + "\n\n" + new Error().stack); };

function $EH(f) {
  return function () {
      try {
        return f.apply(null, arguments);
      } catch (exc) {
        try {
          var msg = ""+exc;
        } catch (rats) {
          var msg = "<error stringifying exception!>";
        }
        document.write("<pre style='border: 3px solid red; padding: 1em'>" + __jtolog + "\n\n"
	  + "<strong>" + msg + "</strong>\n\n"
	  + exc.stack.replace(/@file/g, '\n  file') + "</pre>");
	__jtolog = '';
      }
    };
}

jsx3 = {lang: {}, util: {}};

(function(jsx3) {
  var handleAsyncArgs = function(args) {
    var c = null;
    for (var i = 0; i < args.length; i++) {
      var a = args[i];
      if (a instanceof AsyncRV) {
        if (a._done) {
          args[i] = a.rv();
        } else {
          a.when(fixAsyncArgLambda(i, a));
          c = c ? c.and(a) : a;
        }
      }
    }
    return c;

    function fixAsyncArgLambda(i, a) {
      return function() { args[i] = a.rv(); };
    }
  };

  jsx3.$AsyncCB = function(objThis, arrArgs) {
    this._this = objThis;
    this._args = arrArgs;
    this._condition = handleAsyncArgs(arrArgs);
  };

  jsx3.$AsyncCB.prototype.done = function __AsyncCB_prototype_done(rv) {
    this._done = true;
    this._rv = rv;
  };

  jsx3.$AsyncCB.prototype.args = function() {
    return this._args;
  };

  var AsyncRV = jsx3.$AsyncRV = function() {};
  AsyncRV.prototype._trigger = function __AsyncRV_prototype_trigger(rv) {
      this._done = true;

      this._rv = rv;
      if (this._sub) {
        for (var i = 0; i < this._sub.length; i++)
	  this._sub[i](rv);
        delete this._sub;
      }
    };

  AsyncRV.prototype.rv = function() {
    if (!this._done)
      throw new Error("May not call $AsyncRV.rv() before the return value is set.");
    return this._rv;
  };

  AsyncRV.prototype.when = function(cb, rv) {
    var fct = null;

    if (typeof(cb) == "function")
      fct = cb;
    else if (cb instanceof jsx3.$AsyncCB) {
      if (arguments.length > 1)
	DIE;
      else
	fct = function __AsyncRV_prototype_when_lambda(chainedRV) {cb.done(chainedRV);};
    } else
      throw new Error();

    if (this._done) {
      fct(this._rv);
    } else {
      if (!this._sub)
	this._sub = [];
      this._sub.push(fct);
    }
  }

  var MethodRV = function(cb) {
    var thisMethod = this;

    this._cb = cb;
    cb.done = function __MethodRV_cbdone(rv) {
        cb._done = true;
        cb._rv = rv;
	delete cb.done;
        thisMethod._trigger(rv);
      };
  };
  MethodRV.prototype = new AsyncRV();

  jsx3.$Y = function(f) {
    return function() {
      var cb = new jsx3.$AsyncCB(this, arguments);
      var rv = new MethodRV(cb);

      if (cb._condition) {
        var objThis = this;
        cb._condition.when(function() {
          var r = f.apply(objThis, [cb]);
          if (r instanceof AsyncRV)
            r.when(cb);
        });
      } else {
        var r = f.apply(this, [cb]);
        if (r instanceof AsyncRV)
          r.when(cb);
      }

      return rv;
    };
  };

  jsx3.$Z = function(strMethod, objThis) {
    if (objThis instanceof AsyncRV)
      DIE;

    return function() {
        var rv = new AsyncRV();
        onceDone(objThis || this, strMethod, arguments, rv);
        return rv;
      };
  };

  var onceDone = function(objThis, strMethod, args, rv) {
    var fct = typeof(strMethod) == "function" ? strMethod : objThis[strMethod];
    var c = handleAsyncArgs(args);
    if (c) {
      c.when(function __$Z_onceDone_lambda() {
        rv._trigger(fct.apply(objThis, args))
      });
    } else {
      rv._trigger(fct.apply(objThis, args));
    }
  };
})(jsx3);

(function(lang) {
  lang.getVar = function(strPath) {
    var tokens = strPath.split(".");
    var parent = window;
    for (var i = 0; i < tokens.length; i++) {
      if (parent == null) return;
      parent = parent[tokens[i]];
    }
    return parent;
  };
})(jsx3.lang);

jsx3.lang._NEW_NO_INIT = new window.Object();

jsx3.lang.newConstructor = function() {
  return function() {
    if (arguments[0] !== jsx3.lang._NEW_NO_INIT) {
      if (this.init) {
        this.init.apply(this, arguments);
      } else {
        throw new Error("obj.no_init");
      }
    }
  };
};

jsx3.lang.Object = function() {
  this.init();
};

(function(Object, Object_prototype) {
  Object_prototype.init = function() {};

  Object_prototype.eval = function(strScript, objContext) {
    return jsx3.eval.call(this, strScript, objContext);
  };
})(jsx3.lang.Object, jsx3.lang.Object.prototype);

jsx3.argsAsArray = function(args, from, to) {
    if (from == null)
      from = 0;

    if (to == null)
      to = args.length;
    else
      to = Math.min(to, args.length);

    var length = to - from;
    if (length <= 0) return [];

    var a = new Array(length);
    for (var i = 0; i < length; i++)
      a[i] = args[i+from];

    return a;
  };

jsx3.lang.Class = function() {};

jsx3.lang.Class.prototype = new jsx3.lang.Object;
jsx3.lang.Class.prototype.__jsxclass__ = jsx3.lang.Class;

(function(Class, Class_prototype) {
  Class._SPECIAL = {"jsx3.lang.Object":1, "jsx3.lang.Method":1, "jsx3.lang.ClassLoader": 1, "jsx3.lang.Class": 2};

  Class._NON_ITERATED = ["toString", "valueOf"];

  Class._SKIP_ITERATED = {prototype:1, constructor:1, jsxclass:1, __jsxclass__:1}; // Mozilla browser likes to iterate over the first two

  Class.defineClass = function(strName, objExtends, arrImplements, fctBody) {
    this._define(strName, objExtends, arrImplements, fctBody, false);
  };

  Class.defineInterface = function(strName, objExtends, fctBody) {
    this._define(strName, objExtends, null, fctBody, true);
  };

  Class._define = function(strName, objExtends, arrImplements, fctBody, bInterface) {
    // parse name into package and class name
    var pathTokens = strName.split(".");
    var className = pathTokens.pop();
    var myPackage = this._getOrCreatePackage(pathTokens);
    var bSpecial = this._SPECIAL[strName] != null;

    var fctSuperConstructor = null;
    if (objExtends == null) {
      fctSuperConstructor = (bInterface || strName == "jsx3.lang.Object") ? window.Object : jsx3.lang.Object;
    } else if (objExtends instanceof Class) {
      fctSuperConstructor = objExtends._constructor;
    } else if (typeof(objExtends) == "function" && objExtends.prototype != null) {
      fctSuperConstructor = objExtends;
    } else {
      throw new Error("class.bad_super");
    }

    var bConstructorExists = false;
    if (!bSpecial) {
      // create the constructor, which calls init()
      if (typeof(myPackage[className]) == "function") {
        bConstructorExists = true;
      } else if (bInterface) {
        myPackage[className] = function(){};
      } else if (typeof(myPackage[className]) == "object") {
        // support a class being defined previously as a package ...
        var tmp = myPackage[className];
        myPackage[className] = jsx3.lang.newConstructor();
        for (var f in tmp)
          myPackage[className][f] = tmp[f];
      } else {
        myPackage[className] = jsx3.lang.newConstructor();
      }

      // set up JavaScript inheritance
      myPackage[className].prototype = this._newInstanceNoInit(fctSuperConstructor, bInterface);
    }

    myPackage[className].prototype.__jsxclass__ = myPackage[className];

    var fctConstructor = myPackage[className];
    // create a reference from constructor to jsx3.lang.Class
    if (fctConstructor.jsxclass != null) {
      //throw new Error("class.redefine");
    } else {
      // create the jsx3.lang.Class instance, bootstrap since we use this method to create Class as well
      var objClass = new Class("no init please");
      objClass._name = strName;
      objClass._constructor = fctConstructor; // create 2-way reference, if removed will still work
      objClass._interface = bInterface;
      objClass._staticMethods = [];
      var staticFields = objClass._staticFields = [];
      var instanceFields = objClass._instanceFields = [];

      fctConstructor.jsxclass = objClass;

      // define the body of the class
      fctBody(fctConstructor, fctConstructor.prototype);

      // define instance methods and fields
      for (var f in fctConstructor.prototype) {
        if (Class._SKIP_ITERATED[f]) continue;

        var funct = fctConstructor.prototype[f];
        if (typeof(funct) == "function") {
        } else {
          instanceFields[instanceFields.length] = f;
        }
      }

      // ensure init() method defined
      if (!bConstructorExists && !bInterface && !(typeof(fctConstructor.prototype.init) == "function"))
        throw new Error("class.no_init");

      // import mixin interface methods
      if (arrImplements instanceof Array) {
        // go backwards through interfaces because we clobber and first defined interface has precedence
        for (var i = arrImplements.length-1; i >= 0; i--)
          Class._defineImplements(objClass, fctConstructor, arrImplements[i]);
      }
    }
  };

  Class._defineImplements = function(objClass, fctConstructor, anInterface) {
    if (typeof(anInterface) == "function" && anInterface.jsxclass != null)
      anInterface = anInterface.jsxclass;
    else if (!(anInterface instanceof Class))
      throw new Error("class.bad_int");

    if (!anInterface._interface)
      throw new Error("class.class_imp_class");

    // import interface methods into this class
    var interfacePrototype = anInterface._constructor.prototype;
    for (var f in interfacePrototype) {
      var interfaceFunction = interfacePrototype[f];
      if (!(f in fctConstructor.prototype))
        fctConstructor.prototype[f] = interfaceFunction;
    }
  };

  Class._getOrCreatePackage = function(arrTokens) {
    var node = window;
    for (var i = 0; i < arrTokens.length; i++) {
      var token = arrTokens[i];
      if (node[token] == null) node[token] = {};
      node = node[token];
    }
    return node;
  };

  Class._newInstanceNoInit = function(fctConstructor, bInterface) {
    if (fctConstructor == Object) return {};
    return new fctConstructor(bInterface ? "no init please" : jsx3.lang._NEW_NO_INIT);
  };
})(jsx3.lang.Class, jsx3.lang.Class.prototype);

jsx3.lang.Class.defineClass("jsx3.lang.Class", null, null, function(Class, Class_prototype) {
  Class.forName = function(strName) {
    var c = jsx3.lang.getVar(strName);
    return c ? c.jsxclass : null;
  };

  Class_prototype.mixin = function(obj, bNoClobber, arrNames) {
      for (var i = 0; i < arrNames.length; i++) {
        var name = arrNames[i];
        var method = this._constructor.prototype[name];
        if (!(method instanceof Function)) DIE;
	if (bNoClobber && obj[name]) DIE;
        obj[name] = method;
      }
  };

  Class_prototype.bless = function(obj) {
    return Class._newInstanceNoInit(this._constructor);
  };
});

jsx3.lang.Class.defineClass("jsx3.lang.Object", null, null, function(){});

jsx3.eval = function(strScript, objContext) {
  // name of parameter will be obfuscated so ...
  if (strScript != null && strScript !== "") {
    var vars = "";
    if (objContext) {
      var _ec = objContext;
      var a = [];

      for (var f in _ec)
	a[a.length] = "var " + f + " = _ec." + f + ";";

      vars = a.join("");
    }
    return eval(vars + strScript);
  }
};

jsx3.lang.Class.defineInterface("jsx3.util.EventDispatcher", null, function(EventDispatcher, EventDispatcher_prototype) {
  EventDispatcher._OBJ_FUNCT = 1;
  EventDispatcher._OBJ_STRING = 2;
  EventDispatcher._FUNCT = 5;

  EventDispatcher_prototype.subscribe = function(strEventId, objHandler, objFunction) {
    var type1 = typeof(objHandler);
    var type2 = typeof(objFunction);

    var toAdd = null;
    if (type2 == "function") {
      toAdd = [EventDispatcher._OBJ_FUNCT, objHandler, objFunction];
    } else if (type2 == "string") {
      toAdd = [EventDispatcher._OBJ_STRING, objHandler, objFunction];
    } else if (type1 == "function") {
      toAdd = [EventDispatcher._FUNCT, objHandler];
    }

    var registry = this._getEventRegistry();
    var eventId = strEventId;

    if (!registry[eventId])
      registry[eventId] = [toAdd];
    else
      registry[eventId].push(toAdd);
  };

  EventDispatcher_prototype.publish = function __EventDispatcher_prototype_publish(objEvent) {
    // always set the event target
    if (objEvent.target == null)
      objEvent.target = this;

    var strEventId = objEvent.subject;
    if (strEventId == null)
      throw new Error("illegal argument: objEvent=" + objEvent);

    var reg = this._jsxeventreg;

    if (!reg) return;

    var q1 = reg[strEventId];
    var q2 = reg["*"];

    var queue = [];
    if (q1) queue.push.apply(queue, q1);
    if (q2) queue.push.apply(queue, q2);

    for (var i = 0; i < queue.length; i++) {
      var item = queue[i];
      var type = item[0];
      var target = item[1];
      var method = item[2];

      if (type == EventDispatcher._OBJ_FUNCT) {
        method.call(target, objEvent);
      } else if (type == EventDispatcher._OBJ_STRING) {
        target[method](objEvent);
      } else if (type == EventDispatcher._FUNCT) {
        target.call(null, objEvent);
      } else {
        DIE;
      }
    }

    return queue.length;
  };

  EventDispatcher_prototype._getEventRegistry = function() {
    if (this._jsxeventreg == null)
      this._jsxeventreg = {};
    return this._jsxeventreg;
  };
});

jsx3.lang.Class.defineClass("jsx3.xml.Entity", null, null, function(Entity, Entity_prototype) {
  Entity._initSelf = function(self, node) {
    self._entity = node;
    self._nodeType = node.nodeType;
  }

  Entity_prototype.init = function(objEntity) {
    Entity._initSelf(this, objEntity);
  };

  Entity_prototype.getAttributeNames = function() {
    var att = this._entity.attributes;
    var names = new Array(att.length);
    for (var i = 0; i < names.length; i++)
      names[i] = att[i].nodeName;
    return names;
  };

  Entity_prototype.getRootNode = function() {
    return new Entity(this._entity.ownerDocument.documentElement);
  };

  Entity_prototype.children = function(bIncludeText) {
    var nodes = this._entity.childNodes;
    var children = [];
    for (var i = 0; i < nodes.length; i++) {
      var node = nodes[i];
      if (node.nodeType == 1 ||
          (bIncludeText && (node.nodeType == 3 || node.nodeType == 4)))
        children[children.length] = new Entity(node);
    }
    return children;
  };

  Entity_prototype.getNodeName = function() {
    return this._entity.nodeName;
  };

  Entity_prototype.getNamespaceURI = function() {
    //return as simple string; no need to wrap
    //TO DO: there seeems to be an inconsistency with the signature in firefox (bugzilla). make sure an empty string is returned
    var sns = this._entity.namespaceURI;
    if(sns == null) sns = "";
    return sns;
  };

  Entity_prototype.selectSingleNode = function(strQuery, strNS) {
    return this._selectNodeOrNodes(strQuery, strNS, 0);
  };

  Entity_prototype.selectNodeIterator = function(strQuery, strNS) {
    return this._selectNodeOrNodes(strQuery, strNS, 2);
  };

  Entity_prototype.getBaseName = function() {
    //return as simple string; no need to wrap
    var strNodeName = this.getNodeName();
    var index = strNodeName.indexOf(":");
    return index >= 0 ? strNodeName.substring(index+1) : strNodeName;
  };

  Entity_prototype.getValue = function() {
    if (this._nodeType == 1) {
      var tokens = new Array(this._entity.childNodes.length);
      for (var i = 0; i < this._entity.childNodes.length; i++) {
        var child = this._entity.childNodes[i];
        if (child.nodeType == 3 || child.nodeType == 4)
          tokens[i] = child.nodeValue;
        else
          tokens[i] = child.textContent;
      }
      return tokens.join("");
    } else {
      return this._entity.nodeValue;
    }
  };

  Entity._XPE = new XPathEvaluator();

  Entity._RESULT_TYPES = [XPathResult.FIRST_ORDERED_NODE_TYPE,
      XPathResult.ORDERED_NODE_ITERATOR_TYPE,
      XPathResult.ORDERED_NODE_SNAPSHOT_TYPE];

  Entity_prototype._selectNodeOrNodes = function(strQuery, strNS, intMode) {
    if (typeof(strNS) == "object")
      strNS = "xmlns:amp='http://www.tibco.com/gi/amp'";

    var doc = this._entity.ownerDocument;
    var root = doc.documentElement;
    var nsResolver = strNS ? Entity._createNSResolver(strNS, root) :
        (Entity._getDocNSResolver(doc) || Entity._XPE.createNSResolver(root));

    var objResult = null;
    objResult = Entity._XPE.evaluate(strQuery, this._entity, nsResolver, Entity._RESULT_TYPES[intMode], null);

    if (intMode == 2) {
      return new Entity.SelectIterator(objResult);
    } else {
      return objResult && objResult.singleNodeValue ? new Entity(objResult.singleNodeValue) : null;
    }
  };

  Entity._getDocNSResolver = function(doc) {
    if (! doc._jsxselectionnsobj) {
      if (doc._jsxselectionns)
        doc._jsxselectionnsobj = Entity._createNSResolver(doc._jsxselectionns);
    }
    return doc._jsxselectionnsobj;
  };

  Entity._createNSResolver = function(ns) {
    var nsDoc = (new DOMParser()).parseFromString('<foo ' + ns + '/>', "text/xml");
    return Entity._XPE.createNSResolver(nsDoc.documentElement);
  };

  Entity_prototype.child = function(name) {
    var cn = this._entity.childNodes;
    for (var i = 0; i < cn.length; i++) {
      var c = new Entity(cn[i]);
      if (c._entity.nodeType == 1 && c.getBaseName() == name)
        return c;
    }
    return null;
  };
});

jsx3.lang.Class.defineClass("jsx3.xml.Entity.SelectIterator", null, [], function(Iterator, Iterator_prototype) {
  Iterator_prototype.init = function(i) {
    this._i = i;
    this._n = 0;
    this._entity = null;
  };

  Iterator_prototype.next = function() {
    var next = this._i.snapshotItem(this._n++);
    if (!next) return null;

    if (this._entity) {
      this._entity.init(next);
    } else {
      this._entity = new jsx3.xml.Entity(next);
    }

    return this._entity;
  };

  Iterator_prototype.hasNext = function() {
    return this._i && this._n < this._i.snapshotLength;
  };
});

jsx3.lang.Class.defineClass("jsx3.net.Request", null, [jsx3.util.EventDispatcher], function(Request, Request_prototype) {
  Request.STATUS_ERROR = 400;
  Request.EVENT_ON_RESPONSE = "response";
  Request.trackArray = {};

  Request_prototype.init = function(id) {
    if (id != null)
      Request.trackArray[id] = this;
    this._request = new XMLHttpRequest();
  };

  Request_prototype.getStatus = function() {
    var s = this._status != null ? this._status : this._request.status;
    return s == 0 ? 200 : s;
  };

  Request_prototype.getResponseText = function() {
    return this._request.responseText;
  };

  Request_prototype.open = function(strMethod, strURL, bAsync, strUser, strPass) {
    this._status = 0;
    this._async = Boolean(bAsync);
    this._method = strMethod;
    this._url = strURL;

    //open the request, passing in relevant info and return object ref
    this._request.open(strMethod, this._url, this._async, strUser, strPass);
    return this;
  };

  Request_prototype.send = function(strContent, intTimeout) {
    if (this._status == Request.STATUS_ERROR)
      throw new Error("req.err_state");

    var bError = false;

    this._request.send(strContent);
    if (this._async)
      this._status = 0;
    else
      delete this._status;

    // if this async, add the request object to the array of
    if (this._async) {
      if (bError || this._request.readyState == 4) {
        DIE;
      } else {
        var me = this;
        this._request.onreadystatechange = $EH(function() {
          if (me._request.readyState == 4) {
            me._onReadyStateChange();
          }
        });
      }
    }

    return this;
  };

  Request_prototype._onReadyStateChange = function() {
    delete this._status;
    this._request.onreadystatechange = new Function();
    jot("document loaded: " + this._url);
    this.publish({subject:Request.EVENT_ON_RESPONSE});
  };
});

jsx3.lang.Class.defineClass("jsx3.xml.Document", jsx3.xml.Entity, [jsx3.util.EventDispatcher], function(Document, Document_prototype) {
  var Entity = jsx3.xml.Entity;

  Document.ON_RESPONSE = "response";

  Document_prototype.init = function(objDoc) {
    this._jsxasync = false;
    var bEnt = objDoc instanceof Entity;
    if (!objDoc || bEnt) {
      this._document = window.document.implementation.createDocument("", "", null);
      if (objDoc) {
        this._document.appendChild(objDoc.getNative().cloneNode(true));
        Entity._initSelf(this, this._document.documentElement);
      }
    } else {
      this._document = objDoc;
      Entity._initSelf(this, objDoc.documentElement);
    }
  };

  Document_prototype.load = function(strURL, intTimeout) {
    __jtolog += "loading document: " + strURL + "\n";
    var net = jsx3.net;
    var Request = net.Request;

    this._url = strURL.toString();
    var bAsync = this._jsxasync;

    var req = new Request().open("GET", strURL, bAsync);
    if (bAsync)
      req.subscribe("*", this, "_onRequestEvent");

    req.send(null, intTimeout);

    if (!bAsync)
      this._initFromReq(req);

    return this;
  };

  Document_prototype._initFromReq = function(objReq) {
    var url = this._url;
    this.loadXML(objReq.getResponseText());
    this._url = url;

    this.publish({subject:Document.ON_RESPONSE});
  };

  Document_prototype._onRequestEvent = function(objEvent) {
    var Request = jsx3.net.Request;
    var req = objEvent.target;
    var strSubject = objEvent.subject;

    if (strSubject == Request.EVENT_ON_RESPONSE)
      this._initFromReq(req);
  };

  Document_prototype._initEntity = function(objElm) {
    Entity.prototype.init.call(this, objElm);
  };

  Document_prototype.loadXML = function(strXML) {
    this._url = null;
    this._document = (new DOMParser()).parseFromString(strXML, "text/xml");
    this._initEntity(this._document.documentElement);
    return this;
  };

  Document_prototype.setSelectionNamespaces = function(declaration) {
    this._document._jsxselectionns = "xmlns:jsx1='urn:tibco.com/v3.0'";
    this._document._jsxselectionnsobj = null;
  };
});

jsx3.lang.Class.defineClass("jsx3.app.Model", null, [jsx3.util.EventDispatcher], function(Model, Model_prototype) {
  var Entity = jsx3.xml.Entity;
  var Document = jsx3.xml.Document;

  Model.PERSISTNONE = 0;
  Model.PERSISTEMBED = 1;
  Model.PERSISTREF = 2;
  Model.PERSISTREFASYNC = 3;
  Model.LT_NORMAL = 0;
  Model.LT_SLEEP_PAINT = 1;
  Model.LT_SLEEP_DESER = 2;
  Model.LT_SLEEP_PD = 3;
  Model.LT_SHOW_PAINT = 4;
  Model.LT_SHOW_DESER = 5;
  Model.CURRENT_VERSION = "urn:tibco.com/v3.0";
  Model.FRAGMENTNS = "JSXFRAG";

  Model_prototype._jsxparent = null;
  Model_prototype._jsxchildren = null;
  Model_prototype._jsxns = null;
  Model_prototype._jsxserver = null;

  Model_prototype.init = function(strName) {
    this.jsxname = strName;
  };

  Model_prototype.getChildren = function() {
    if (this._jsxchildren == null) this._jsxchildren = [];
    return this._jsxchildren;
  };

  Model_prototype.setChild = function __Model_prototype_setChild(objChild, intPersist, strSourceURL, strNS) {
    //find out the server that will own this object instance
    var bFragment = false;
    if (strNS == null && this._jsxns == null) {
      strNS = Model.FRAGMENTNS;
    } else if (strNS != null) {
      bFragment = true;
    } else {
      strNS = this._jsxns;
    }

    var objServer = this.getServer();

    //only add this item to a server instance if not part of the 'fragment' ns
    if (strNS != Model.FRAGMENTNS && objServer && this._jsxns == strNS) DIE;

    //create an array to hold child if not yet created
    var children = this._jsxchildren;
    if (!children) children = this._jsxchildren = [];

    //increment the array and reference the new object
    children[children.length] = objChild;
    objChild._jsxparent = this;

    //set persistent type and urls if applicable
    if (intPersist == null) intPersist = Model.PERSISTNONE;
    objChild._jsxpersistence = intPersist;

    return this;
  };

  Model_prototype.getServer = function() {
    var node = this;
    while (node) {
      if (node._jsxserver) return node._jsxserver;
      node = node._jsxparent;
    }
    return null;
  };

  Model_prototype.getDescendantOfName = function(strName, bDepthFirst, bChildOnly) {
    return this.findDescendants(function(x){ return x.jsxname == strName; },
        bDepthFirst, false, bChildOnly, false);
  };

  Model_prototype.findDescendants = function(fctTest, bDepthFirst, bMultiple, bShallow, bIncludeSelf) {
    var fctPush = bDepthFirst ? 'unshift' : 'push';
    var matches = bMultiple ? [] : null;
    var list = bIncludeSelf ? [this] : this.getChildren().concat();

    while (list.length > 0) {
      var node = list.shift();

      if (fctTest.call(null, node)) {
        if (bMultiple)
          matches[matches.length] = node;
        else
          return node;
      }

      if (! bShallow)
        list[fctPush].apply(list, node.getChildren());
    }

    return matches;
  };

  Model_prototype.loadXML = function(strXML, bRepaint) {
    //parse xml and pass to common handler
    var objXML = strXML instanceof Document ? strXML : (new Document()).loadXML(strXML);
    return this._loadObject(objXML, bRepaint, null, objXML._url, objXML._url)[0];
  };

  Model_prototype._loadObject = function(objXML, bRepaint, intPersist, strSourceURL, strRawURL) {
    // determine which deserialization routine to use based upon the xmlns attribute for the serialization file
    if (objXML.getRootNode().getNamespaceURI().indexOf(Model.CURRENT_VERSION) != 0) {
      throw new Error("model.bad_vers");
    }

    var serPath = "/jsx1:serialization/";

    objXML.setSelectionNamespaces("xmlns:jsx1='" + Model.CURRENT_VERSION + "'");

    //derive the namespace that should be used (infer if not explicitly passed)
    var strNS = this._jsxns;

    var attachedServer = this.getServer();
    var objServer = attachedServer;

    //deserialize and bind new component as a child this instance
    var i = objXML.selectNodeIterator(serPath + "jsx1:object | " + serPath + "jsx1:objects/jsx1:object | /jsx1:object");
    var objToInsert = [];

    var loadContext = {uri:strSourceURL};

    while (i.hasNext()) {
      //get node descriptor in the XML serializatoin file and deserialize the node as a child of 'this' object
      var objNode = i.next();
      var objJSX = this._doLoad(objNode, strSourceURL, strNS, objServer, loadContext);

      //if a valid child resulted (was the serialzation file valid and the referenced GUI object type a valid class?)
      if (objJSX != null) {
        //this item is a valid JSX GUI object will be added as a child to the MODEL; track it so it can auto-inserted (as DHTML) into the VIEW
        objToInsert[objToInsert.length] = objJSX;

        var success = this.setChild(objJSX, intPersist, strSourceURL, strNS);
        if (success === false) return false;
      }
    }

    //update the view by iterating through all GUI objects that were just added to the model by adding their DHTML directly into the view
    if (bRepaint !== false) {
      for (var j = 0; j < objToInsert.length; j++)
        this.viewUpdateHook(objToInsert[j], j < objToInsert.length - 1);
    }

    //return handle to last item deserialized
    return objToInsert;
  };

  Model_prototype._doLoad = function(objXML, strSourceURL, strNS, objServer, loadContext) {
    if (objXML == null) return null;

    //get the JSX foundation class that the object will be an instance of
    var strType = objXML._entity.getAttribute("type");
    var objClass = jsx3.lang.Class.forName(strType);

    //create the object instance of the given class and set its 'jsxtype' property
    var objInstance = objClass.bless();
    objInstance._jsxloadcontext = loadContext;
    objInstance._jsxns = strNS;

    //call functions that will extract variant, dynamic, and string data types and apply to the object instance
    for (var i = objXML.selectNodeIterator("jsx1:strings"); i.hasNext(); )
      Model._applyStringAttributes(objInstance, i.next());

    var i = objXML.selectNodeIterator("jsx1:object");
    while (i.hasNext()) {
      var objItem = i.next();

      var objNewChild = objInstance._doLoad(objItem, strSourceURL, strNS, objServer, loadContext);
      if (objNewChild) {
	objInstance.setChild(objNewChild, Model.PERSISTEMBED, null, strNS);
      }
    }
    return objInstance;
  };

  Model._applyStringAttributes = function(objInstance, objXML) {
    var names = objXML.getAttributeNames();
    for (var i = 0; i < names.length; i++) {
      var name = names[i];
      objInstance[name] = objXML._entity.getAttribute(name);
    }
  };
});

jsx3.lang.Class.defineClass("jsx3.gui.Painted", jsx3.app.Model, null, function() {});
jsx3.lang.Class.defineClass("jsx3.gui.Block", jsx3.app.Model, null, function() {});
jsx3.lang.Class.defineClass("jsx3.gui.LayoutGrid", jsx3.app.Model, null, function() {});
jsx3.lang.Class.defineClass("jsx3.gui.WindowBar", jsx3.app.Model, null, function() {});
jsx3.lang.Class.defineClass("jsx3.gui.Menu", jsx3.app.Model, null, function() {});
jsx3.lang.Class.defineClass('jsx3.gui.Window', jsx3.app.Model, null, function() {});

jsx3.lang.Class.defineClass("jsx3.amp.Ext", null, null, function(Ext, Ext_prototype) {
  Ext_prototype.init = function(objPlugIn, objElm) {
    this._xml = objElm;
    this._plugin = objPlugIn;
  };

  Ext_prototype.getPlugIn = function() { // called from xml via eval right now
    return this._plugin;
  };
});

jsx3.lang.Class.defineClass("jsx3.amp.ExtPoint", null, [jsx3.util.EventDispatcher], function(ExtPoint, ExtPoint_prototype) {
  var amp = jsx3.amp;

  ExtPoint_prototype.init = function(objPlugIn, objElm) {
    if (objElm == "__layout__") {
      this._isLayout = true;
      this._localId = "layout";
    } else {
      this._localId = objElm._entity.getAttribute("id");
      this._xml = objElm;
    }
    this._plugin = objPlugIn;
  };

  ExtPoint_prototype.getExts = function() {
    return this._plugin._engine.getExts(this._plugin._id + "." + this._localId);
  };

  ExtPoint_prototype.processExts = function() {
    var objProcessor = this._isLayout ? amp.ExtProc.RETURN_ASYNC : amp.ExtProc.RETURN;
    var arrExt = this.getExts();
    return amp.ExtProc.process(arrExt, objProcessor);
  };
});

jsx3.lang.Class.defineClass("jsx3.amp.ExtProc", null, null, function(ExtProc, ExtProc_prototype) {
  var amp = jsx3.amp;

  ExtProc.process = function(arrExt, objVisitor) {
    var o = [];

    for (var i = 0; i < arrExt.length; i++) {
      var ext = arrExt[i];
      var data = ext._xml.children();
      for (var j = 0; j < data.length; j++) {
        var elm = data[j];
        o.push(objVisitor.process(ext, elm));
      }
    }

    return o;
  };

  ExtProc.RETURN = {
    process: function(objExt, objData) { throw fit; }
  };

  ExtProc.RETURN_ASYNC = {
    process: jsx3.$Y(function(cb) {
      var objExt = cb.args()[0];
      var objData = cb.args()[1];

      var bLoad = objData._entity.getAttribute("load") == "true";
      var script = objData.getValue();

      if (bLoad) {
        objExt._plugin.load().when(function __ExtProc_RETURN_ASYNC_process_onLoad() {
          cb.done(objExt.eval(script));
        });
      } else {
        cb.done(objExt.eval(script));
      }
    })
  };
});

jsx3.lang.Class.defineClass("jsx3.amp.PlugIn", null, [jsx3.util.EventDispatcher], function(PlugIn, PlugIn_prototype) {
  var amp = jsx3.amp;

  PlugIn_prototype.init = function() {
    this._loaded = false;
    this._req = [];
    this._resources = [];
    this._extptmap = {};
    this._ext = [];
    this._extmap = {};
  };

  PlugIn_prototype.setAmpMainPlugIn = function() {
    this._id = "jsx3.amp.main";
    this._name = "";
    var xp = new amp.ExtPoint(this, "__layout__");
    var id = xp._localId;
    this._extptmap[id] = xp;
  };

  PlugIn_prototype.setUIPlugIn = function(objElm) {
//   <plugin
//       name="UI Plug-In">
//     <extension-point id="menubar-ext">
//       <processor type="return"/>
//     </extension-point>
//     <extension point="jsx3.amp.main.layout" id="main-layout">
//       <eval load="true">var p = this.getPlugIn(); ...some junk...</eval>
//     </extension>
//   </plugin>

    this._id = "jsx3.ide.ui";
    this._name = "";

    var children = objElm.children();
    for (var i = 0; i < children.length; i++) {
      var node = children[i];
      var name = node.getBaseName();

      if (name == "extension-point") {
        var xp = new amp.ExtPoint(this, node);
        this._extptmap['menubar-ext'] = xp;
      } else if (name == "extension") {
        var x = new amp.Ext(this, node);
        this._extmap['main-layout'] = x;
        this._ext.push(x);
      }
    }
  };

  PlugIn_prototype.setResources = function(arrRsrc) {
    this._resources = arrRsrc;
    for (var i = 0; i < arrRsrc.length; i++)
      arrRsrc[i]._plugin = this;
  };

  PlugIn_prototype.getRequires = function() {
    return this._req;
  };

  PlugIn_prototype.load = jsx3.$Y(function(cb) {
    return this._engine._loadPlugIn(this);
  });

  PlugIn_prototype.loaded = jsx3.$Y(function(cb) {
    if (this._loaded)
      cb.done();
  });

  PlugIn_prototype._onLastResourceLoaded = function __PlugIn_prototype_onLastResourceLoaded() {
    this._loaded = true;
  };

  PlugIn_prototype.getExtPoint = function(strId) {
    return this._extptmap[strId];
  };

  PlugIn_prototype.getExts = function() {
    return this._ext;
  };

  PlugIn_prototype.onStartup = function() {
  };

  PlugIn_prototype.loadRsrcComponent = function(objParent, bPaint) {
    var rsrc = this._resources[0];
    return objParent.loadXML(rsrc._data, false);
  };
});

jsx3.lang.Class.defineClass("jsx3.amp.Resource", null, [jsx3.util.EventDispatcher], function(Resource, Resource_prototype) {
  var amp = jsx3.amp;

  Resource.NOT_LOADED = 0;
  Resource.LOADING = 1;
  Resource.LOADED = 2;

  Resource._newBeforePlugIn = function(elm, objEngine) {
    // elm = <xml id="layout" path="layout.xml"/>
    var rsrc = new Resource(null, "layout", elm);
    rsrc._pluginid = "jsx3.ide.ui";
    rsrc._pluginpath = "/GI_Builder/plugins/jsx3.ide.ui/";
    return rsrc;
  };

  Resource_prototype.init = function(objPlugIn, strId, elm) {
    this._xml = elm;
    this._plugin = objPlugIn;
    this._id = strId;
    this._loaded = false;
    this._data = null;
  };
});

jsx3.lang.Class.defineClass("jsx3.amp.Engine", null, [jsx3.util.EventDispatcher], function(Engine, Engine_prototype) {
  var amp = jsx3.amp;
  var Document = jsx3.xml.Document;

  Engine.XML_NS = {"http://www.tibco.com/gi/amp": "amp"};
  Engine.ERROR = "error";
  Engine.REGISTER = "register";

  Engine._init = function() {
  };

  Engine_prototype.getBodyBlock = function() {
    if (!this.JSXROOT) {
      if (this._jsxroots == null) this._jsxroots = [];

      var root = new jsx3.gui.Block("JSXROOT", 0, 0, "100%", "100%", "");
      root._jsxns = void 0;
      root._jsxserver = this;
      this._jsxroots.push(root);
      this.JSXROOT = root;

      var body = this.JSXBODY = new jsx3.gui.Block("JSXBODY",0,0,"100%","100%","");
      root.setChild(body);
    }
    return this.JSXBODY;
  };

  Engine_prototype.init = function() {
    this._plugins = [];
    this._extptmap = {};
    this._extmap = {};

    var p = new jsx3.amp.Main();
    p._engine = this;
    p.setAmpMainPlugIn();
    p.setResources([]);

    this._plugins.push(p);
    this._loadPlugIn(p);

    var engine = this;
    var mainXML = Engine._loadXML("GI_Builder/plugins/plugins.xml", function (doc) {
      engine._loadGIBuilderPluginsDescriptor(doc);
      p.onStartup();
    });
  };

  Engine_prototype._loadGIBuilderPluginsDescriptor = function(objXML) {
    var objElm = objXML.children()[0];
    var rsrcXML = objElm.selectSingleNode("amp:resources", Engine.XML_NS);
    var e = rsrcXML.children()[0];
    var rsrc = amp.Resource._newBeforePlugIn(e, this);
    var p = new jsx3.ide.ui.PlugIn();
    p._engine = this;

    p.setUIPlugIn(objElm);
    p.setResources([rsrc]);

    this._plugins.push(p);

    var exs = p.getExts();
    if (exs.length != 1) DIE;
    var ex = exs[0];
    var pointId = "jsx3.amp.main.layout";
    this._extmap[pointId] = [ex];
  };

  Engine_prototype.getExts = function(strId) {
    return this._extmap[strId] || [];
  };

  Engine_prototype._loadPlugIn = jsx3.$Y(function(cb) {
    var objPlugIn = cb.args()[0];
    var rsrcDone = this._loadNormalRsrcs(objPlugIn);
    return jsx3.$Z(this._onAfterPlugInLoaded, this)(objPlugIn, rsrcDone); // 2nd parameter for ordering only
  });

  Engine_prototype._onAfterPlugInLoaded = function __Engine_prototype_onAfterPlugInLoaded(objPlugIn) {
    objPlugIn._loaded = true;
  };

  Engine_prototype._loadNormalRsrcs = jsx3.$Y(function(cb) {
    var objPlugIn = cb.args()[0];
    var condRV = null;

    var arrRsrc = objPlugIn._resources
    for (var i = 0; i < arrRsrc.length; i++) {
      var r = arrRsrc[i];
      if (!r._loaded) {
        var c = this._loadResourceShared(r);
        condRV = condRV ? condRV.and(c) : c;
      }
    }

    if (condRV) return condRV;
    else cb.done();
  });

  Engine_prototype._loadResourceShared = jsx3.$Y(function(cb) {
    var objResource = cb.args()[0];

    var strRsrcPath = objResource._xml._entity.getAttribute("path");
    var strSrc = "GI_Builder/plugins/jsx3.ide.ui/layout.xml";

    Engine._loadXML(strSrc, function __Engine_prototype_loadResourceShared_onLoaded(data) {
      objResource._loaded = true;
      objResource._data = data;
      cb.done();
    });
  });

  Engine._loadXML = function(path, callback) {
    var d = new jsx3.xml.Document;
    d._jsxasync = true;
    d.subscribe("*", function() {
      callback(d);
    });
    d.load(path);
  };
});

jsx3.lang.Class.defineClass("jsx3.amp.Main", jsx3.amp.PlugIn, null, function(Main, Main_prototype) {
  Main_prototype.onExtension = function(objExtPt, arrExts) {
    if (objExtPt._localId == "layout") {
      for (var i = 0; i < arrExts.length; i++) {
        var p = arrExts[i]._plugin;
	p._engine._loadPlugIn(p);
      }
    }
  };

  Main_prototype.onStartup = function() {
    // Make sure that required plug-ins are loaded before doing this.
    var self = this;
    this.loaded().when(function __Main_prototype_onStartup_outerLambda() {
      var layouts = self.getExtPoint("layout").processExts();
      var container = self._engine.getBodyBlock();
      layouts[0].when(function __Main_prototype_onStartup_innerLambda(rv) { rv(container); });
    });
  };
});

jsx3.lang.Class.defineClass("jsx3.amp.util.MenuItem", null, null, function(MenuItem, MenuItem_prototype) {});
jsx3.lang.Class.defineClass("jsx3.amp.util.Menu", jsx3.amp.util.MenuItem, null, function(Menu, Menu_prototype) {});

jsx3.lang.Class.defineClass("jsx3.ide.ui.PlugIn", jsx3.amp.PlugIn, null, function(PlugIn, PlugIn_prototype) {
  PlugIn_prototype.paintLayout = function __PlugIn_prototype_paintLayout(objContainer) {
    var layout = this.loadRsrcComponent(objContainer, false);
    var mainMenu = layout.getDescendantOfName("mainMenu");

    // Insert any extensions to the menubar.
    var exts = this.getExtPoint("menubar-ext").processExts();
    var objChild = exts[0];
    var Model = jsx3.app.Model;
    var objServer = mainMenu.getServer();
    if (!objServer)
      objServer.die();
    alert("bug fixed (or test case disrupted); objServer is: " + objServer);
  };
});

$EH(function __jsx_main() {
  new jsx3.amp.Engine;
})();

jot("end of main body of JSX30.js");
